#include "strings.h"

static char dst[28] = "OOOOOOOOOOOOOOOOOOOOOOOOOO/";
static char src[28] = "ABCDEFGHIJKLMNOPRSTUQVWXYZ/";
static char* pps;
static char* m1 = "ABCDEFGHIJKLMNOPRSTUQVWXYZ/";
static char* m2 = "ABCDEFGHIJKMLNOPRSTUQVWXYA/";
static char* y1 = "XYZ";
static char* y2 = "XYU";
static int res;

main(){
 pps = memset(dst, 'A', 0);
 printf("memset(dst, 'A',  0); dst=%.27s\n", pps);
 pps = memset(dst, 'X', 3);
 printf("memset(dst, 'X',  3); dst=%.27s\n", pps); 
 pps = memset(dst, '_', 26);
 printf("memset(dst, '_', 26); dst=%.27s\n", pps);
 
 pps = memcpy(dst, src, 0);
 printf("memcpy(dst, src,  0); dst=%.27s\n", pps);
 pps = memcpy(dst, src, 3);
 printf("memcpy(dst, src,  3); dst=%.27s\n", pps); 
 pps = memcpy(dst, src, 26);
 printf("memcpy(dst, src, 26); dst=%.27s\n", pps);

 res = memcmp(m1, m2, 3);
 printf("memcmp(m1, m2, 3); res=%i\n", res); 
 res = memcmp(m1, m2, 26);
 printf("memcmp(m1, m2, 26); res=%i\n", res);
 res = memcmp(m2, m1, 26);
 printf("memcmp(m2, m1, 26); res=%i\n", res);
 res = memcmp(m1, m2, 0);
 printf("memcmp(m1, m2, 0); res=%i\n", res);
 res = memcmp(y1, y2, 3);
 printf("memcmp(y1, y2, 3); res=%i\n", res);

 pps = memmove(dst, dst, 4);
 printf("memmove(dst, dst, 4); dst=%s\n", pps); 
 pps = memmove(dst, dst+3, 0);
 printf("memmove(dst, dst+3, 0); dst=%s\n", pps); 
 pps = memmove(dst, dst+2, 4);
 printf("memmove(dst, dst+2, 4); dst=%s\n", pps);
 pps = memmove(dst+3, dst, 4);
 printf("memmove(dst+3, dst, 4); dst=%s\n                        pps=%s\n", dst, pps);
 
 pps = strcpy(dst, y1);
 printf("strcpy(dst, y1); dst=%s\n", pps);

 pps = strncpy(dst, src, 15);
 printf("strcpy(dst, src, 15); dst=%s\n", pps);
 pps = strncpy(dst, y2, 15);
 printf("strcpy(dst, y2, 15); dst=%s\n", pps);

 res = strcmp(m1, m2);
 printf("strcmp(m1, m2); res=%i\n", res); 
 res = strcmp(m1, m1);
 printf("strcmp(m1, m1); res=%i\n", res); 
 res = strcmp(m2, m1);
 printf("strcmp(m2, m1); res=%i\n", res); 

 res = strncmp(m1, m2, 3);
 printf("strncmp(m1, m2, 3); res=%i\n", res); 
 res = strncmp(m1, m2, 30);
 printf("strncmp(m1, m2, 30); res=%i\n", res);
 res = strncmp(m2, m1, 30);
 printf("strncmp(m2, m1, 30); res=%i\n", res);
 res = strncmp(m1, m2, 0);
 printf("strncmp(m1, m2, 0); res=%i\n", res);

 res = (int) strcat(dst,y1);
 printf("strcat(dst, y1); dst=%s\n", res);

 pps = strncat(dst,y2,2);
 printf("strncat(dst, y2, 2); dst=%s\n", pps);
 pps = strncat(dst,y2,0);
 printf("strncat(dst, y2, 0); dst=%s\n", pps);

 pps = strchr(dst, 'X');
 printf("strchr(dst,'X'); search=%s\n", pps); 
 pps = strchr(dst, 'Z');
 printf("strchr(dst,'Z'); search=%s\n", pps);

 pps = strrchr(dst, 'X');
 printf("strrchr(dst,'X'); search=%s\n", pps); 
 pps = strrchr(dst, 'Z');
 printf("strrchr(dst,'Z'); search=%s\n", pps);

 pps = strstr(dst, "");
 printf("strstr(dst, \"\"); find=%s\n", pps);
 pps = strstr(dst, "Z");
 printf("strstr(dst, \"Z\"); find=%s\n", pps);
 pps = strstr(dst, "UXY");
 printf("strstr(dst, \"UXY\"); find=%s\n", pps);

 res = strlen("");
 printf("strlen(\"\"); len=%i\n", res);
 res = strlen(m1);
 printf("strlen(m1); len=%i\n", res);
 return 0;
}
